plot.vector <- function (u, v, int = NA, add = TRUE, ...)
{
raster2list <- function (x, y = 1, maxpixels = 1e+05, ...) 
{
if (nlayers(x) > 1) {
  x = raster(x, y)
}
x <- sampleRegular(x, maxpixels, asRaster = TRUE, corners = TRUE)
X <- xFromCol(x, 1:ncol(x))
Y <- yFromRow(x, nrow(x):1)
Z <- t(matrix(getValues(x), ncol = x@ncols, byrow = TRUE)[nrow(x):1, 
                                                          ])
obj <- ls()
obj$x <- X
obj$y <- Y
obj$z <- Z
return(obj)
}

U <- raster2list(u)
V <- raster2list(v)

if(is.na(int)){
  resolution <- res(u)
  icol <- seq(1,ncol(U$z), 1)
  irow <- seq(1,nrow(U$z), 1)
}
if(!is.na(int)){
  resolution <- res(u)*int
  icol <- seq(1,ncol(U$z), int)
  irow <- seq(1,nrow(U$z), int)
}

df <- expand.grid(x=seq(min(U$x), max(U$x), resolution[1]), y=seq(min(U$y), max(U$y), resolution[2]))

if(add == FALSE) {
  plot(df$x,df$y, type = 'n')
  arrow.plot(a1 = df$x, a2 = df$y, u = U$z[irow,icol], v = V$z[irow,icol], ...)
}

if(add == TRUE) {
  arrow.plot(a1 = df$x, a2 = df$y, u = U$z[irow,icol], v = V$z[irow,icol], ...)
}
}