#------------------------------------------------------------------------------------------#
#------------------------------------------------------------------------------------------#
#  This function plots the map for South America, including Brazilian states.              #
#------------------------------------------------------------------------------------------#
southammap = function(mapdir=NULL,...){
  if (is.null(mapdir)){
     arquivo = "americadosul"
  }else{
     arquivo = paste(mapdir,"americadosul",sep="/")
  }
  americadosul = read.table(arquivo,na.string="999")
  amsul=americadosul
  amsul[,1]=amsul[,1]+360
  names(americadosul) = c("lon","lat")
  lines(x=americadosul,...)
  lines(x=amsul,...)
}
#------------------------------------------------------------------------------------------#





#------------------------------------------------------------------------------------------#
#------------------------------------------------------------------------------------------#
#  This function plots the map for South America, including Brazilian states.              #
#------------------------------------------------------------------------------------------#
southammap3d = function(height=0,pmat,xlim=NULL,ylim=NULL,mapdir=NULL,...){

  if (is.null(mapdir)){
     arquivo = "americadosul"
  }else{
     arquivo = paste(mapdir,"americadosul",sep="/")
  }
  americadosul = read.table(arquivo,na.string="999")
  names(americadosul) = c("lon","lat")
  if (! is.null(xlim)){
     sel = americadosul$lon >= xlim[1] & americadosul$lon <= xlim[2]
     americadosul = americadosul[sel,]
  }
  if (! is.null(ylim)){
     sel = americadosul$lat >= ylim[1] & americadosul$lat <= ylim[2]
     americadosul = americadosul[sel,]
  }
  lines(trans3d(x=americadosul$lon,y=americadosul$lat,z=height,pmat),...)
}
#------------------------------------------------------------------------------------------#
