rm(list=ls())
graphics.off()

require(ncdf)

setwd('/home/glauber/aula_R/teste3')

nc <- open.ncdf('dados/reanalise/temp_xyzt.nc')

lat.nc <- get.var.ncdf(nc = nc, varid = 'lat')
lon.nc <- get.var.ncdf(nc = nc, varid = 'lon')
lev.nc <- get.var.ncdf(nc = nc, varid = 'level')
timearr <- get.var.ncdf(nc = nc, varid = 'time')
  
un = nc$var[['air']]$dim[[4]]$units
startTime = substr(un, 13, 30)
startTime = strptime(startTime, "%Y-%m-%d %H:%M:%OS", tz = 'GMT')
time <- startTime+as.numeric(timearr)*3600-2*86400 #retrocede dois dias

loni <- -90
lonf <- -10
lati <- -70 
latf <- 10

lon <- c(loni, lonf)+360.
lat <- c(lati, latf)
lev <- 850

cut.lon <- lon.nc[lon.nc >= lon[1] & lon.nc <= lon[2]]
cut.lat <- lat.nc[lat.nc >= lat[1] & lat.nc <= lat[2]]
cut.lev <- lev

pos.loni <- match(min(cut.lon), lon.nc)
pos.lati <- match(max(cut.lat), lat.nc) #<=== CUIDADO A LATITUDE HE INVERTIDA
pos.levi <- match(min(cut.lev), lev.nc)

vtype <- nc$var[['air']]
varsize <- vtype$varsize
ndims <- vtype$ndims
ntime <- varsize[ndims]
  
start <- rep(1, ndims)
start[1] <- pos.loni
start[2] <- pos.lati
start[3] <- pos.levi
  
nlon <- length(cut.lon)
nlat <- length(cut.lat)
nlev <- length(cut.lev)
  
count <- varsize
count[1] <- nlon
count[2] <- nlat
count[3] <- nlev
  
var <- get.var.ncdf(nc, vtype, start = start, count = count)
  
revlat.var <- array(NA, c(nlon, nlat, ntime))

for (t in 1:ntime) {
  revlat.var[,,t] <- var[,nlat:1,t]
}

temp <- list()
temp$lon <- cut.lon
temp$lat <- rev(cut.lat)
temp$lev <- cut.lev
temp$time <- time
temp$nc <- revlat.var

t <- 13
filled.contour(x = temp$lon, y = temp$lat, z = temp$nc[,,t], main = temp$time[t])
filled.contour(x = temp$lon-360, y = temp$lat, z = temp$nc[,,t], 
               xlab = 'Longitude', ylab = 'Latitude', main = paste('Temperatura', temp$time[t]))
